// QResultWidget.cpp: QResultWidget NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "qover_win32.h"
#include <qstatusbar.h>
#include "qoverdlg.h"
#include "qsearchdlg.h"
#include "qresultwidget.h"
#include "searchthread.h"
#include "shareobj.h"
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
QResultWidget::QResultWidget( QWidget *parent, const char *name )
    : QWidget( parent, name )
{
	m_pThread=0;
	m_pwDownload=(QOverDlg*)parent;
    QVBoxLayout* pvbox = new QVBoxLayout(this, 2);
    QHBoxLayout* phbox = new QHBoxLayout(this, 2);

	m_plvUrl=new QListView(this);
	m_plvUrl->setSorting(-1,false);
	m_plvUrl->addColumn("V");
	m_plvUrl->addColumn("Title");
	m_plvUrl->addColumn("Time");
	m_plvUrl->addColumn("User");
	m_plvUrl->addColumn("ID");
	m_plvUrl->addColumn("Type");
	m_plvUrl->addColumn("Image");
    m_plvUrl->setAllColumnsShowFocus(true);
    m_plvUrl->setColumnWidth(1, 400);
    m_plvUrl->setColumnWidth(2, 100);
    m_plvUrl->setColumnWidth(3, 100);
    m_plvUrl->setColumnWidth(4, 100);
	m_plvUrl->setMultiSelection(true);

	m_pbDownload= new QPushButton("List up(&M)",this);
	m_pbSearch	= new QPushButton("Search(&N)",this);
	m_pbDownload->setAccel(CTRL+'M');
	m_pbSearch->setAccel(CTRL+'N');
	phbox->addWidget(m_pbSearch);
	phbox->addWidget(m_pbDownload);
	pvbox->addWidget(m_plvUrl);
	pvbox->addLayout(phbox);

	m_pdSearch = new QSearchDlg(this->parentWidget(),0,0);

	{	// Cxg
		connect( m_pbSearch  , SIGNAL( clicked() ), this, SLOT( onSearch()   ) );
		connect( m_pbDownload, SIGNAL( clicked() ), this, SLOT( onDownload() ) );
		connect( ((QSearchDlg*)m_pdSearch)->button(), SIGNAL( clicked() ), this, SLOT( onNetwork() ) );
	}
	m_pObj=0;
}

QResultWidget::~QResultWidget()
{

}

void QResultWidget::setObj(shareObj *pObj)
{
	m_pObj=pObj;
	
	int n=0;
	while(engineQov* p=m_pObj->ref_Engine(n++))
	{	
		m_pdSearch->addEngine(p->ref(engine_title));
	}
}

void QResultWidget::onSearch()
{
	if(m_pwDownload->isThread())
	{	// ȂXbhNĂꍇ삳Ȃ
		return;
	}

	m_pdSearch->show();
}

void QResultWidget::onDownload()
{
	if(m_pwDownload->isThread())
	{	// ȂXbhNĂꍇ삳Ȃ
		return;
	}

	QListViewItem* pitem = m_plvUrl->firstChild();
	if(!pitem)
	{
		return;
	}

 	QListView* pDst = m_pwDownload->ref_list();
	m_pwDownload->progress(0,"send to list");
	
    int add=0;
	for(; pitem; pitem=pitem->nextSibling())
	{
		if(!m_plvUrl->isSelected ( pitem ))
		{
			continue;
		}

		QListViewItem* pditem = pDst->firstChild();
		// _E[hXgɓ]	
		for(;pditem;pditem=pditem->nextSibling())
		{
			if(!pitem->text(3).compare(pditem->text(3)))
			{	// ID
				break;
			}
		}

		if(!pditem)
		{	// IDo^Ȃ
			pDst->insertItem(new QListViewItem( pDst,pitem->text(0),pitem->text(1),pitem->text(2),pitem->text(3),pitem->text(4),pitem->text(5),pitem->text(6) ));
			add++;
		}
	}

	if(add)
	{
		for(int n=0;n<=10;n++)
		{
			m_pwDownload->progress(n*10,0);
			SLEEP(10);
		}
	}
	m_pwDownload->progress(0,"");
	m_plvUrl->clearSelection();
}

// 
void QResultWidget::onNetwork()
{	
	QCString osstr;
	
	if(m_pThread)
	{
		m_pThread->cancel();
		return;
	}

	if (!m_pdSearch->string(&osstr))
	{	// ȂƂ͏IƂ܂B
		return;
	}

	m_pdSearch->setButton("Cancel(&L)");

	m_plvUrl->clear();
	m_pThread = new searchThread(m_plvUrl,m_pdSearch->bar(),m_pObj,(const char*)osstr,m_pdSearch->engine(),m_pdSearch->mode(),m_pdSearch->page());
}

int QResultWidget::timeUpdate()
{
	if(!m_pThread)
	{
		return 0;
	}
	if(!m_pThread->status())
	{
		char str[260]; 
		sprintf(str,"%d/%d",m_pThread->current(),m_pThread->all());
		m_pdSearch->bar()->message(str);
		return 1;
	}

	delete m_pThread;
	m_pThread=0;

	m_pdSearch->setButton("Search(&L)");
	return 0;
}
