// QSearchDlg.cpp: QSearchDlg NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "qover_win32.h"
#include <qaccel.h>
#include <qstatusbar.h>
#include "qsearchdlg.h"

#include "urlobj.h"
#include "stringhelper.h"
#include "searchthread.h"
//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
QSearchDlg::QSearchDlg( QWidget *parent, const char *name, WFlags f )
:    QDialog(parent,name,true,f)
{

    m_pvbox = new QVBoxLayout(this, 4);

	// GWύXR{{bNX
	m_pStatus = new QStatusBar(this);
	m_pStatus->setSizeGripEnabled(false);
	m_pvbox->addWidget(m_pStatus);
	{
		m_phbox = new QHBoxLayout(this, 3);
		m_pcmEngine = new QComboBox(this);	
		m_phbox->addWidget(m_pcmEngine);
		m_pcbMode = new QComboBox(this);	
		m_phbox->addWidget(m_pcbMode);
		m_pcbPage = new QComboBox(this);	
		m_phbox->addWidget(m_pcbPage);
		m_pvbox->addLayout(m_phbox);
	}
	m_pleSearch  = new QLineEdit(this);
	m_pvbox->addWidget(m_pleSearch);
	m_pbSearch  = new QPushButton("Search(&L)",this);
	m_pbSearch->setAccel(CTRL+'L');
	m_pvbox->addWidget(m_pbSearch);


	// p^[
	m_pcbMode->insertItem("Title",-1);
	m_pcbMode->insertItem("User",-1);
	m_pcbMode->insertItem("URL",-1);

	char num[4];
	for(int n=0;n<20;n++)
	{
		sprintf(num,"%02d",n);
		m_pcbPage->insertItem(num,-1);
	}

	QAccel* pKey=new QAccel(this);

	pKey->connectItem(pKey->insertItem(Qt::Key_J+CTRL,    200),this,SLOT(incEngine()));
	pKey->connectItem(pKey->insertItem(Qt::Key_K+CTRL,    201),this,SLOT(decEngine()));

	pKey->connectItem(pKey->insertItem(Qt::Key_Left+CTRL, 202),this,SLOT(incMode()));
	pKey->connectItem(pKey->insertItem(Qt::Key_Right+CTRL,203),this,SLOT(decMode()));

	pKey->connectItem(pKey->insertItem(Qt::Key_Up+CTRL,   204),this,SLOT(incPage()));
	pKey->connectItem(pKey->insertItem(Qt::Key_Down+CTRL, 205),this,SLOT(decPage()));
}

QSearchDlg::~QSearchDlg()
{
}

int QSearchDlg::page()
{
	return m_pcbPage->currentItem();
}

int QSearchDlg::engine()
{
	return m_pcmEngine->currentItem();
}

int QSearchDlg::mode()
{
	return m_pcbMode->currentItem();
}

int QSearchDlg::string(QCString *cstr)
{
	*cstr=m_pleSearch->text().CONVERT_TR();
	return cstr->length();
}

int QSearchDlg::addEngine(const char* pstr)
{
	if(pstr)
	{
		m_pcmEngine->insertItem(pstr);
		return 1;
	}
	return 0;
}

QWidget* QSearchDlg::button()
{
	return m_pbSearch;
}

void QSearchDlg::setButton(char* str)
{
	m_pbSearch->setText(str);
	m_pbSearch->setAccel(CTRL+'L');
}

void QSearchDlg::incEngine()
{
	int n=m_pcmEngine->currentItem()+1;
	if (n<m_pcmEngine->count())
	{
		m_pcmEngine->setCurrentItem(n);
	}
}

void QSearchDlg::decEngine()
{
	int n=m_pcmEngine->currentItem()-1;
	if (n>-1)
	{
		m_pcmEngine->setCurrentItem(n);
	}
}

void QSearchDlg::incMode()
{
	int n=m_pcbMode->currentItem()+1;
	if (n<m_pcbMode->count())
	{
		m_pcbMode->setCurrentItem(n);
	}
}

void QSearchDlg::decMode()
{
	int n=m_pcbMode->currentItem()-1;
	if (n>-1)
	{
		m_pcbMode->setCurrentItem(n);
	}
}

void QSearchDlg::incPage()
{
	int n=m_pcbPage->currentItem()+1;
	if (n<m_pcbPage->count())
	{
		m_pcbPage->setCurrentItem(n);
	}
}

void QSearchDlg::decPage()
{
	int n=m_pcbPage->currentItem()-1;
	if (n>-1)
	{
		m_pcbPage->setCurrentItem(n);
	}
}
