// urlObj.cpp: urlObj NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "qover_win32.h"

#include "urlobj.h"
#include "stringhelper.h"

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

urlObj::urlObj()
{
	for(int n=0;n<estEnd;n++)
	{
		pqcsData[n]=new QCString(" ");
	}

	strcpy(stName[Host],"Host:" );
	strcpy(stName[Accept],"Accept:" );
	strcpy(stName[Referer],"Referer:" );
	strcpy(stName[UserAgent],"User-Agent:" );
	strcpy(stName[AcceptLanguage],"Accept-Language:" );
	strcpy(stName[ProxyConnection],"Proxy-Connection:" );
	strcpy(stName[Connection],"Connection:" );
	strcpy(stName[Range],"Range:" );
	strcpy(stName[Cookie],"Cookie:" );
	strcpy(stName[Ip]  ,"" );
	strcpy(stName[estWork]  ,"" );

	set(Host,"");
	set(Accept,"*/*");
	set(Referer,"");
	set(UserAgent,"");
	set(AcceptLanguage,"ja");
	set(ProxyConnection,"");
	set(Connection,"close");
	set(Range,"");
	set(Cookie,"");
	set(Ip,"");
	set(estWork,"");
}

urlObj::~urlObj()
{
	for(int n=0;n<estEnd;n++)
	{
		delete pqcsData[n];
	}
}

void urlObj::set(estMode mode,const char* stSet)
{
	*pqcsData[mode]=stSet;
	nData[enWork]=0;
}

const char* urlObj::ref(estMode mode)
{
	return *pqcsData[mode];
}

void urlObj::set(enMode mode,int nSet)
{
	nData[mode]=nSet;
}

int urlObj::ref(enMode  mode)
{
	return nData[mode];
}

const char* urlObj::string(const char* stSet)
{
	int nSize=strlen(stSet);
	if(nSize<4096)
	{
		nSize=4096;
	}
	char* ptmp=new char[nSize];

	sprintf(ptmp,"GET http://%s%s HTTP/1.0\r\n",ref(Host),stSet);
	*pqcsData[estWork]=ptmp;
	for(int i=0;i<Ip;i++)
	{
		if(1<pqcsData[i]->length())
		{
			sprintf(ptmp,"%s %s\r\n",stName[i],ref((estMode)i));
			*pqcsData[estWork]+=ptmp;	
		}
	}

	*pqcsData[estWork]+="\r\n";
	delete [] ptmp;
	return *pqcsData[estWork];
}

const char* urlObj::string_proxy(const char* stSet)
{
	int nSize=strlen(stSet);
	if(nSize<4096)
	{
		nSize=4096;
	}
	char* ptmp=new char[nSize];

	sprintf(ptmp,"GET %s HTTP/1.0\r\n",stSet);
	*pqcsData[estWork]=ptmp;

	for(int i=0;i<Ip;i++)
	{
		if(1<pqcsData[i]->length())
		{
			sprintf(ptmp,"%s %s\r\n",stName[i],ref((estMode)i));
			*pqcsData[estWork]+=ptmp;	
		}
	}

	*pqcsData[estWork]+="\r\n";
	delete [] ptmp;
	return *pqcsData[estWork];
}

int urlObj::setHostFromURL(const char* pUrl, char** ppNext)
{
	char* p=new char [strlen(pUrl)+1];
	strcpy(p,pUrl);
	*ppNext=0;

	char* pSlash2=strstr(p,"//");
	if(!pSlash2)
	{
		delete [] p;
		return -1;
	}

	char* pSlash=strstr(&pSlash2[2],"/");
	if(!pSlash)
	{
		delete [] p;
		return -1;
	}
	*pSlash='\0';
	*ppNext=(char*)&pUrl[pSlash-p];

	// RefererȂꍇ͐ݒ肷
	if(strlen(ref(Referer)))
	{
		set(Referer,p);
	}

	char* pBeforHost=(char*)ref(Host);
	if(pBeforHost)
	{
		if(0==strcmp(pBeforHost,&pSlash2[2]))
		{
			// OqzXgƓ
			delete [] p;
			return 1;
		}
	}
	set(Host,&pSlash2[2]);
	delete [] p;
	return 0;
}

httpHelper::httpHelper()
{
	m_pqbaBuffer		=new QByteArray(128*1024+4);
	m_pqbaHeader		=new QByteArray(1);

	m_dummy[0]			=' ';
	m_dummy[1]			='\0';
	m_pLocation			=m_dummy;
	m_pContentType		=m_dummy;
	m_pqcsUrl			=new QCString(" ");
	m_pqcsProxyName		=new QCString(" ");
	m_pqcsUserName		=new QCString(" ");
	m_pqcsPassName		=new QCString(" ");
	m_pS				=0;
	m_nBinaryMode		=0;
	m_nState		=0;
	m_nTimeout		=10000;
	m_nAllDataSize	=0;
	m_nReadDataSize	=0;
	m_nBufferSize	=128*1024;
	m_nBufferUseSize=0;
	m_nRetry		=0;
	m_nProxyPort	=0;
}

httpHelper::~httpHelper()
{
	delete	m_pqbaBuffer;
	delete	m_pqbaHeader;
	delete  m_pqcsUrl;
	delete  m_pqcsProxyName;
	delete  m_pqcsUserName;
	delete  m_pqcsPassName;
	delete	m_pS;
}

// wb_͕̉
char* httpHelper::headerRead(const char* pcSrc)
{
	char* p=0;
	char* pNext=0;	
	char szEnd[2][5]={"\r\n\r\n","\n\n"};
	for(int i=0;i<2;i++)
	{	// I[`FbNswb_̏ImF
		if( (p=strstr(pcSrc,szEnd[i])) )
		{
			pNext=&p[strlen(szEnd[i])];
			break;
		}
	}
	if (!p)
	{	// ܂I[͌Ȃ
		return 0;
	}

	m_pqbaHeader->resize(p-pcSrc+4);
	char* pHeader=m_pqbaHeader->data();
	memcpy(pHeader,pcSrc,p-pcSrc);
	memset(&pHeader[p-pcSrc],0,4);

	// ef[^̃|C^m
	m_pLocation=strstr(pHeader,"Location: ");
	if(!m_pLocation)
	{
		m_pLocation=m_dummy;
	}
	m_pContentType=strstr(pHeader,"Content-Type: ");
	if(!m_pContentType)
	{
		m_pContentType=m_dummy;
	}
	char* pLength=strstr(pHeader,"Content-Length: ");

	for(int n=0 ;pHeader[n]!='\0' ;n++)
	{	// f[^̏I[ݓǂ݂₷
		if(pHeader[n]=='\r' ||pHeader[n]=='\n')
		{
			pHeader[n]='\0';
		}
	}

	// f[^̊m
	m_nAllDataSize=-1;
	if(pLength)
	{
		m_nAllDataSize=atoi(&pLength[15]);
	}

	// Xe[^X̊m
	for(int m=9;pHeader[m]!='\0';m++)
	{
		if(pHeader[m]==' ')
		{
			pHeader[m]='\0';
			m_nState=atoi(&pHeader[m]);
			break;
		}
	}
	return pNext;
}

// User_Agentݒ肷B
void httpHelper::setUserAgent(const char* pstr)
{
	m_url.set(urlObj::UserAgent,pstr);
}

void httpHelper::setBinaryMode(int n)
{
	m_nBinaryMode=n;
}

// timeoutԂ̐ݒ
void httpHelper::setTimeout(int nTime)
{
	m_nTimeout=nTime;
}

void httpHelper::setRetry(int nCount)
{
	m_nRetry=nCount;
}

void httpHelper::setProxy(const char* psProxy, int nPort)
{
	*m_pqcsProxyName=" ";
	if(psProxy)
	{
		*m_pqcsProxyName=psProxy;
	}
	m_nProxyPort=nPort;
}

void httpHelper::setUser(const char* psUser,const char* psPass)
{
	*m_pqcsUserName=" ";
	*m_pqcsPassName=" ";
	if(psUser)
	{
		*m_pqcsUserName=psUser;
	}
	if(psPass)
	{
		*m_pqcsPassName=psPass;
	}
}

// ڑBheader܂ł͋AĂȂB
int httpHelper::connect(const char* pUrl)
{
	char* pNext	=0;
	char* p_ref =0;
	int nPort	=0;
	QHostAddress myaddress;

	if(1<m_pqcsProxyName->length())
	{	// proxy ݒ
		m_url.setHostFromURL(pUrl,&pNext);
		pNext=(char*)pUrl;
		nPort=m_nProxyPort;
		myaddress.setAddress(QString(*m_pqcsProxyName));	
		p_ref=(char*)m_url.string_proxy(pNext);
	}
	else
	{	// ڐڑ
		int nSameUrl=m_url.setHostFromURL(pUrl,&pNext);
		if(0>nSameUrl)
		{
			return -1;
		}
		nPort=80;

		char szIp[32]={0};
		gethostip(szIp  ,m_url.ref(urlObj::Host));
		myaddress.setAddress(QString(szIp));
//		p_ref=(char*)m_url.string(pNext);
		p_ref=(char*)m_url.string_proxy(pNext);
	}

	delete m_pS;	
	m_pS=new QSocketDevice(QSocketDevice::Stream);
	m_pS->setBlocking(true);
	if(!m_pS->connect ( myaddress, nPort ))
	{
		return -2;	
	}

	if (0>=m_pS->writeBlock(p_ref,strlen(p_ref)))
	{
		return -3;
	}

	int nReadDataSize=0;
	char* pBuffer=m_pqbaBuffer->data();
	
	while(1)
	{
		if(0>=m_pS->waitForMore(m_nTimeout))
		{	// wb_邱ƂȂ@^CAEg
			break;			
		}

		nReadDataSize+=m_pS->readBlock(&pBuffer[nReadDataSize],m_nBufferSize-nReadDataSize);
		pBuffer[nReadDataSize]='\0';

		char* pData =headerRead(pBuffer);
		if(pData)
		{	// wb_̏I[
			m_nBufferUseSize=&pBuffer[nReadDataSize]-pData;
			if(m_nBufferUseSize<=0)
			{
				m_nBufferUseSize=0;
				pBuffer[0]='\0';
			}
			else
			{
				memmove(pBuffer,pData,&pBuffer[nReadDataSize]-pData);		
			}
			m_nReadDataSize=m_nBufferUseSize;
			return m_nBufferUseSize;
		}
	}	

	return -4;
}

// ڑBheader܂ł͋AĂȂB
int httpHelper::reconnect()
{
	// ƃR[hȂƂȂ
	return -25;
}

int httpHelper::connectEx(const char* pUrl)
{
	int nRev=0;

	*m_pqcsUrl=" ";
	if(pUrl)
	{
		*m_pqcsUrl=pUrl;
	}

	do
	{
		nRev=connect(pUrl);
		if(0>nRev)
		{
			return nRev;
		}
		pUrl=&m_pLocation[10];
	}while(strlen(m_pLocation)>1);
	
	return nRev;
}

int httpHelper::bufferring()
{
	if (!m_pS)
	{
		return -5;
	}
	
	if (m_nBufferUseSize==m_nBufferSize)
	{	// ǂ߂Ȃ
		return 1;
	}

	if (m_nAllDataSize>0)
	{
		if(m_nAllDataSize<=m_nReadDataSize)
		{	// f[^Ȃ
			return 2;	
		}
	}

	if(0>=m_pS->waitForMore(m_nTimeout))
	{	// f[^ǂ߂^CAEg
		int nRet=reconnect();
		if(nRet<=0)
		{	
			return nRet;			
		}
	}

	char* pBuffer=m_pqbaBuffer->data();
	int nCurrentSize=m_pS->readBlock(&pBuffer[m_nBufferUseSize],m_nBufferSize-m_nBufferUseSize);
	m_nBufferUseSize+=nCurrentSize;
	m_nReadDataSize+=nCurrentSize;
	pBuffer[m_nBufferUseSize]='\0';

	int nLast=m_nBufferUseSize-1024;
	if(nLast<0)
	{
		nLast=0;
	}
	if (m_nBinaryMode==0)
	{	// html̏I[IɌ
		if( strstr(&pBuffer[nLast],"</HTML>") || strstr(&pBuffer[nLast],"</html>") )
		{
			m_nAllDataSize=m_nReadDataSize;
		}
	}
	return 0;
}

// obt@TCY
int httpHelper::bufferSize()
{
	return m_nBufferSize;
}

// obt@̂pĂTCY
int httpHelper::bufferUseSize()
{
	return m_nBufferUseSize;
}

// wb_ɂĂf[^TCY
int httpHelper::allDataSize()
{
	return m_nAllDataSize;
}

// ܂łɓǂݍ񂾃f[^TCY
int httpHelper::readDataSize()
{
	return m_nReadDataSize;
}

char* httpHelper::refBuffer()
{
	return m_pqbaBuffer->data();
}

void httpHelper::frashBuffer()
{
	m_nBufferUseSize=0;
	m_pqbaBuffer->data()[0]	='\0';
}


const char* httpHelper::ref_Host()
{
	return m_url.ref(urlObj::Host);
}
